risks_project/urls.py
from django.contrib import admin
from django.conf.urls import include
from django.urls import path


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(('risks_types.urls', 'risks_types'), namespace='risks_types')),
]

risks_types/urls.py
from django.urls import path

from risks_types.views import MainPageView, RiskTypesPageView, RiskTypesList, RiskTypesDetail, \
    RisksList, RisksDetail, RiskTypesAddPageView, RiskTypesEditPageView


urlpatterns = [
    path('', MainPageView.as_view(), name='main_page'),
    path('risk_types/', RiskTypesPageView.as_view(), name='risk_types'),
    path('risk_types/add/', RiskTypesAddPageView.as_view()),
    path('risk_types/edit/<int:pk>/', RiskTypesEditPageView.as_view()),

    path('api/risk_types/', RiskTypesList.as_view()),
    path('api/risk_types/<int:pk>/', RiskTypesDetail.as_view()),
    path('api/risks/', RisksList.as_view()),
    path('api/risks/<int:pk>/', RisksDetail.as_view()),
]

risks_types/models.py
from django.db import models


class RiskType(models.Model):
    type_name = models.CharField(max_length=255)


class RiskTypeField(models.Model):
    FIELD_TYPE_INTEGER = 'Integer'
    FIELD_TYPE_TEXT = 'Text'
    FIELD_TYPE_DATE = 'Date'
    FIELD_TYPE_ENUM = 'Enum'
    FIELD_TYPE_BOOLEAN = 'CheckBox'

    FIELD_TYPE_CHOICES = (
        (FIELD_TYPE_INTEGER, 'Integer'),
        (FIELD_TYPE_TEXT, 'Text'),
        (FIELD_TYPE_DATE, 'Date'),
        (FIELD_TYPE_ENUM, 'Enum'),
        (FIELD_TYPE_BOOLEAN, 'CheckBox'),
    )

    risk_type = models.ForeignKey(RiskType, on_delete=models.CASCADE, related_name='risk_type_fields')
    field_name = models.CharField(max_length=255)
    field_type = models.CharField(max_length=8, choices=FIELD_TYPE_CHOICES, default=FIELD_TYPE_TEXT)

    class Meta:
        ordering = ('id',)


class RiskTypeFieldEnum(models.Model):
    value = models.CharField(max_length=64)
    risk_type_field = models.ForeignKey(RiskTypeField, on_delete=models.CASCADE, related_name='enum_values')

    class Meta:
        ordering = ('id',)


class Risk(models.Model):
    risk_name = models.CharField(max_length=255)
    risk_type = models.ForeignKey(RiskType, on_delete=models.CASCADE, related_name='risk_type')


class RiskField(models.Model):
    risk = models.ForeignKey(Risk, on_delete=models.CASCADE, related_name='risk_fields')
    risk_type_field = models.ForeignKey(RiskTypeField, on_delete=models.CASCADE, related_name='risk_type_field')
    value = models.CharField(max_length=255, null=True, blank=True, default='')

    class Meta:
        ordering = ('id',)

risks_types/views.py
from django.views.generic import View
from django.shortcuts import render

from rest_framework import generics

from risks_types.models import RiskType, Risk
from risks_types.serializers import RiskTypeSerializer, RiskSerializer


class MainPageView(View):
    template_name = 'index.html'

    def get(self, request, *args, **kwargs):
        return render(request, self.template_name)


class RiskTypesPageView(View):
    template_name = 'risk_types.html'

    def get(self, request, *args, **kwargs):
        return render(request, self.template_name)


class RiskTypesAddPageView(View):
    template_name = 'risk_types_add.html'

    def get(self, request, *args, **kwargs):
        return render(request, self.template_name)


class RiskTypesEditPageView(View):
    template_name = 'risk_types_edit.html'

    def get(self, request, *args, **kwargs):
        return render(request, self.template_name)


class RiskTypesList(generics.ListCreateAPIView):
    queryset = RiskType.objects.all().order_by('id')
    serializer_class = RiskTypeSerializer


class RiskTypesDetail(generics.RetrieveUpdateDestroyAPIView):
    queryset = RiskType.objects.all()
    serializer_class = RiskTypeSerializer


class RisksList(generics.ListCreateAPIView):
    queryset = Risk.objects.all()
    serializer_class = RiskSerializer


class RisksDetail(generics.RetrieveUpdateDestroyAPIView):
    queryset = Risk.objects.all()
    serializer_class = RiskSerializer

risks_types/templates/base.html
{% extends 'adminlte/base.html' %}

{% load staticfiles %}


{% block title %}Risks Project{% endblock %}


{% block stylesheets %}
    {% include 'styles.html' %}
{% endblock %}


{% block body_class %}fixed{% endblock %}


{% block content_header %}{% endblock %}


{% block content %}{% endblock %}


{% block nav_header %}
    {% include 'main_header.html' %}
{% endblock %}


{% block nav_sidebar %}
    {% include 'sidebar_menu.html' %}
{% endblock %}


{% block nav_footer %}
    {% include 'main_footer.html' %}
{% endblock %}


{% block javascript %}
    {% include 'scripts.html' %}
{% endblock %}

risks_types/templates/index.html
{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Risks Project{% endblock %}

{% block content %}
    <div class="box" id="risk_types_list">

        <div class="box-header with-border">
            <h3 class="box-title">Test Project for Risk Management</h3>
        </div>

        <div class="box-body">

            <div class="list-group">
                <a href="risk_types/" class="list-group-item list-group-item-action active bg-green-gradient text-bold">
                    Risk Types&nbsp; <i class="fa fa-external-link-square"></i>
                </a>
                <li class="list-group-item">List of risk types</li>
                <li class="list-group-item">Add new risk type</li>
                <li class="list-group-item">Edit risk type</li>
                <li class="list-group-item">Delete risk type</li>
            </div>

        </div>

        <div class="box-footer clearfix">
            <a class="btn text-bold pull-right btn-primary bg-purple" href="https://gitlab.com/ivan.dibrova/risks_project">
                <i class="fa fa-gitlab text-orange"></i>&nbsp;Link to GitLab Repository
            </a>
        </div>

    </div>

{% endblock %}

{% block javascript %}
    {{ block.super }}
{% endblock %}

risks_types/templates/main_footer.html
<footer class="main-footer">

    <div class="pull-right hidden-xs">

        {% block footer_right %}
            <b>Version</b> {% block version %}1.0{% endblock %}
        {% endblock %}

    </div>

    {% block footer_left %}

        {% block legal %}
            <strong>Copyright &copy; {% now "Y" %}{% if not site %}.{% endif %}
                {% if site %}
                    <a href="http://{{ site.domain }}">{{ site.name }}</a>
                {% endif %}
            </strong> All rights reserved.
        {% endblock %}

    {% endblock %}

</footer>

risks_types/templates/main_header.html
{% extends 'adminlte/lib/_main_header.html' %}


{% block logo %}

    <a href="{% block logo_href %}/{% endblock %}" class="logo">
        <span class="logo-mini">{% block logo_text_small %}<b>R</b>isks{% endblock %}</span>
        <span class="logo-lg">{% block logo_text %}<b>Risks</b> Project{% endblock %}</span>
    </a>

{% endblock %}

risks_types/templates/risk_types.html
{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Risk Types{% endblock %}

{% block content %}
    <div class="box" id="risk_types_list">

        <div class="box-header with-border bg-green-gradient">
            <h3 class="box-title text-bold">Risk Types List</h3>
        </div>

        <div class="box-body">
            <div>
                <input class="col-sm-3 margin-r-5 margin-bottom" style="height: 33px; vertical-align: bottom"
                       type="text" placeholder="Search" v-model="search_term" aria-label="Search">
                <button class="btn btn-primary text-bold" v-on:click.prevent="getRiskTypes()">
                    <i class="fa fa-search"></i>&nbsp;Search
                </button>
                <a class="btn btn-danger text-bold" v-bind:href="'add/'"><i class="fa fa-file"></i>&nbsp;Add Risk Type</a>
            </div>

            <table class="table table-bordered">
                <thead class="bg-gray-light">
                    <tr>
                        <th style="width: 10px">#</th>
                        <th>Name</th>
                        <th>Fields</th>
                        <th style="width: 90px">Buttons</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(riskType, index) in riskTypes">
                        <td>${index + 1}</td>
                        <td>${riskType.type_name}</td>
                        <td>
                            <template v-for="(risk_type_field, risk_type_field_index) in riskType.risk_type_fields">
                                <span v-if="risk_type_field_index == riskType.risk_type_fields.length - 1">
                                    ${risk_type_field.field_name} (${risk_type_field.field_type})
                                </span>
                                <span v-else>
                                    ${risk_type_field.field_name} (${risk_type_field.field_type}),
                                </span>
                            </template>
                        </td>

                        <td>
                            <a class="btn btn-primary btn-sm" v-bind:href="'edit/' + riskType.id + '/'">
                                <i class="fa fa-edit"></i>
                            </a>
                            <button class="btn btn-danger btn-sm" v-on:click="deleteRiskType(riskType.id)">
                                <i class="fa fa-trash-o fa-lg"></i>
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

    </div>

{% endblock %}

{% block javascript %}
    {{ block.super }}

    <script type="text/javascript" src="{% static 'js/risk_types.js' %}"></script>
{% endblock %}

risks_types/templates/risk_types_add.html
{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Add Risk Type{% endblock %}

{% block content %}

    <div id="risk_types_add">

        <div class="box">
            <form v-on:submit.prevent="addNewRiskType()">
                <div class="box-header with-border bg-green-gradient">
                    <h3 class="box-title text-bold">Add Risk Type</h3>
                </div>
                <div class="box-body">

                    <div>
                        <input class="col-sm-4 margin-bottom margin-r-5" style="height: 33px" type="text" v-model="typeName"
                               placeholder="Risk Type Name" v-model="type_name" id="risk_type">
                        <span id="risk_type_error" class="text-bold text-red" hidden></span>
                        <button type="button" class="btn btn-danger text-bold"
                                v-on:click.prevent="addNewRiskTypeField()">
                            <i class="fa fa-file"></i>&nbsp;Add Risk Type Field
                        </button>
                    </div>

                    <table class="table table-bordered">
                        <thead class="bg-gray-light">
                            <tr>
                                <th style="width: 10px">#</th>
                                <th>Field Name</th>
                                <th>Field Type</th>
                                <th style="width: 90px">Buttons</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(riskTypeField, index) in riskTypeFields">
                                <td>${index + 1}</td>
                                <td>${riskTypeField.field_name}</td>
                                <td>
                                    <template v-if="riskTypeField.field_type != 'Enum'">
                                        ${riskTypeField.field_type}
                                    </template>
                                    <template v-else>
                                        ${riskTypeField.field_type}(
                                        <template v-for="(enumValue, index) in riskTypeField.enum_values">
                                            <span v-if="index == riskTypeField.enum_values.length - 1">
                                                 ${enumValue}
                                            </span>
                                            <span v-else>
                                                 ${enumValue},&nbsp;
                                            </span>
                                        </template>
                                        )
                                    </template>

                                </td>
                                <td>
                                    <button class="btn btn-primary btn-sm"
                                            v-on:click.prevent="editRiskTypeField(index)">
                                        <i class="fa fa-edit"></i>
                                    </button>
                                    <button class="btn btn-danger btn-sm"
                                            v-on:click.prevent="deleteRiskTypeField(index)">
                                        <i class="fa fa-trash-o fa-lg"></i>
                                    </button>
                                </td>
                            </tr>
                        </tbody>
                    </table>

                </div>

                <div class="box-footer">
                    <button type="submit" class="btn btn-primary pull-right text-bold" id="save_risk_type">
                        <i class="fa fa-save"></i>&nbsp;Save New Risk Type
                    </button>
                </div>
            </form>
        </div>

        <div class="modal fade" id="addRiskTypeFieldModal" tabindex="-1" role="dialog" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-light-blue-gradient">
                        <span class="modal-title text-bold">Add Risk Type Field</span>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true" class="text-bold">x</span>
                        </button>
                    </div>
                <form v-on:submit.prevent="addNewRiskTypeField()">
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="field_name">Field Name</label>
                            <input type="text" class="form-control" id="field_name" value=""
                                   placeholder="Enter Risk Type Field Name" v-model="newRiskTypeField.field_name"
                                   required>
                            <span id="field_name_error" class="text-bold text-red" hidden></span>
                        </div>
                        <div class="form-group">
                            <label for="field_type">Field Type</label>
                            <select class="form-control" id="field_type" v-model="newRiskTypeField.field_type"
                                    required>
                                <option value="Integer">Integer</option>
                                <option value="Text">Text</option>
                                <option value="Date">Date</option>
                                <option value="Enum">Enum</option>
                                <option value="CheckBox">CheckBox</option>
                            </select>
                            <span id="field_type_error" class="text-bold text-red" hidden></span>
                        </div>

                        <div v-if="newRiskTypeField.field_type == 'Enum'">

                            <button style="vertical-align: bottom" class="btn btn-success margin-r-5"
                                    v-on:click.prevent="addEnumValue()">Add Enum Value
                            </button>
                            <input style="vertical-align: bottom; height: 35px" type="text" id="enum_value"
                                   placeholder="Enter Enum Value" v-model="currentEnumValue"
                                   required="required" >
                            <span id="enum_value_error" class="text-bold text-red" hidden></span>

                            <table class="table table-bordered" id="enum_table">
                                <tbody>
                                    <tr v-for="(enumValue, index) in currentEnumValues">
                                        <td>${enumValue}</td>
                                        <td style="width: 20px">
                                             <button class="btn btn-danger btn-sm"
                                                     v-on:click.prevent="deleteEnumValue(index)">
                                                 <i class="fa fa-trash-o fa-lg"></i>
                                             </button>
                                        </td>
                                    </tr>
                                </tbody>

                            </table>

                        </div>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger m-progress text-bold" data-dismiss="modal">
                            Close
                        </button>
                        <button type="submit" class="btn btn-primary text-bold"
                                v-on:click.prevent="saveAddNewRiskTypeField()">
                            <i class="fa fa-plus"></i>&nbsp;Add New Risk Type Field
                        </button>
                    </div>
                </form>
                </div>
            </div>
        </div>

        <div class="modal fade" id="editRiskTypeFieldModal" tabindex="-1" role="dialog" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-light-blue-gradient">
                        <span class="modal-title text-bold">Edit Risk Type Field</span>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true" class="text-bold">x</span>
                        </button>
                    </div>
                <form v-on:submit.prevent="saveRiskTypeField()">
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="field_name">Field Name</label>
                            <input type="text" class="form-control" id="edit_field_name" value=""
                                   placeholder="Enter Risk Type Field Name" v-model="currentRiskTypeField.field_name"
                                   required>
                            <span id="edit_field_name_error" class="text-bold text-red" hidden></span>
                        </div>
                        <div class="form-group">
                            <label for="field_type">Field Type</label>
                            <select class="form-control" id="edit_field_type" v-model="currentRiskTypeField.field_type"
                                    required>
                                <option value="Integer">Integer</option>
                                <option value="Text">Text</option>
                                <option value="Date">Date</option>
                                <option value="Enum">Enum</option>
                                <option value="CheckBox">CheckBox</option>
                            </select>
                            <span id="edit_field_type_error" class="text-bold text-red" hidden></span>
                        </div>

                        <div v-if="currentRiskTypeField.field_type == 'Enum'">

                            <button style="vertical-align: bottom" class="btn btn-success margin-r-5"
                                    v-on:click.prevent="addEditEnumValue()">Add Enum Value
                            </button>
                            <input style="vertical-align: bottom; height: 35px" type="text" id="edit_enum_value"
                                   placeholder="Enter Enum Value" v-model="currentEditEnumValue"
                                   required="required" >
                            <span id="edit_enum_value_error" class="text-bold text-red" hidden></span>

                            <table class="table table-bordered" id="edit_enum_table">
                                <tbody>
                                    <tr v-for="(enumEditValue, edit_index) in currentEditEnumValues">
                                        <td>${enumEditValue}</td>
                                        <td style="width: 20px">
                                             <button class="btn btn-danger btn-sm"
                                                     v-on:click.prevent="deleteEditEnumValue(edit_index)">
                                                 <i class="fa fa-trash-o fa-lg"></i>
                                             </button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>

                        </div>

                    </div>

                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger m-progress text-bold" data-dismiss="modal">
                            Close
                        </button>
                        <button type="submit" class="btn btn-primary text-bold"
                                v-on:click.prevent="saveEditedRiskTypeField()">
                            <i class="fa fa-plus"></i>&nbsp;Save Risk Type Field
                        </button>
                    </div>
                </form>
                </div>
            </div>
        </div>

    </div>

{% endblock %}

{% block javascript %}
    {{ block.super }}

    <script type="text/javascript" src="{% static 'js/risk_types_add.js' %}"></script>
{% endblock %}

risks_types/templates/scripts.html
{% extends 'adminlte/lib/_scripts.html' %}

{% load staticfiles %}

{% block scripts %}

    {{ block.super }}

    <script type="text/javascript" src="{% static 'bower_components/jquery-slimscroll/jquery.slimscroll.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'bower_components/vue/dist/vue.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'bower_components/vue-resource/dist/vue-resource.min.js' %}"></script>

{% endblock %}

risks_types/templates/sidebar_menu.html
{% extends 'adminlte/lib/_main_sidebar.html' %}

{% block user_panel %}{% endblock %}

{% block nav_links %}
    <!-- sidebar: style can be found in sidebar.less -->
    <section class="sidebar">
        <!-- Sidebar Menu -->
        <ul class="sidebar-menu">

            <li>
                <a href="{% url 'risks_types:risk_types' %}">
                    <i class="fa fa-calendar"></i> <span>Risk Types</span>
                </a>
            </li>

        </ul>
        <!-- /.sidebar-menu -->
    </section>
    <!-- /.sidebar -->
{% endblock nav_links %}

risks_types/templates/styles.html
{% extends 'adminlte/lib/_styles.html' %}

{% load staticfiles %}

{% block styles %}

    {{ block.super }}

{% endblock %}